#######
#
# E-scripts on show-conses.el.
#
# Note 1: use the eev command (defined in eev.el) and the
# ee alias (in my .zshrc) to execute parts of this file.
# Executing this file as a whole makes no sense.
# An introduction to eev can be found here:
#
#   (find-eev-quick-intro)
#   http://anggtwu.net/eev-intros/find-eev-quick-intro.html
#
# Note 2: be VERY careful and make sure you understand what
# you're doing.
#
# Note 3: If you use a shell other than zsh things like |&
# and the for loops may not work.
#
# Note 4: I always run as root.
#
# Note 5: some parts are too old and don't work anymore. Some
# never worked.
#
# Note 6: the definitions for the find-xxxfile commands are on my
# .emacs.
#
# Note 7: if you see a strange command check my .zshrc -- it may
# be defined there as a function or an alias.
#
# Note 8: the sections without dates are always older than the
# sections with dates.
#
# This file is at <http://anggtwu.net/e/show-conses.e>
#           or at <http://anggtwu.net/e/show-conses.e.html>.
#        See also <http://anggtwu.net/emacs.html>,
#                 <http://anggtwu.net/.emacs[.html]>,
#                 <http://anggtwu.net/.zshrc[.html]>,
#                 <http://anggtwu.net/escripts.html>,
#             and <http://anggtwu.net/>.
#
#######



# «.totext»	(to "totext")
# «.class»	(to "class")




#####
#
# totext
# 2024oct18
#
#####

# «totext»  (to ".totext")

;;;  _____     _            _   
;;; |_   _|__ | |_ _____  _| |_ 
;;;   | |/ _ \| __/ _ \ \/ / __|
;;;   | | (_) | ||  __/>  <| |_ 
;;;   |_|\___/ \__\___/_/\_\\__|
;;;                             
;; Tests:
;;   (find-estring-2a (show-conses-totext-line (nth 0 show-conses-demo-lines-3)))
;;   (find-estring-2a (show-conses-totext-lines show-conses-demo-lines-3))
;;
(defun show-conses-totext-1 (o)
  (cond ((stringp o)      o)
	((eq 'm (car o)) "")		; delete markers
	((eq 'h (car o)) (show-conses-propertize-h o))
	(t "?")))
  
(defun show-conses-totext-line (line)
  (let* ((expandedline (show-conses-expand-line line))
	 (strs (mapcar 'show-conses-totext-1 expandedline)))
    (apply 'concat strs)))
	 
(defun show-conses-totext-lines (lines)
  (let* ((expandedlines (show-conses-expand-lines lines))
	 (strs (mapcar 'show-conses-totext-line expandedlines)))
    (mapconcat 'identity strs "\n")))






#####
#
# class
# 2024oct18
#
#####

# «class»  (to ".class")

;; (find-eieionode "Quick Start")
;; (find-eieionode "Building Classes")
;; (find-eieionode "Slot Options" ":initarg")

;; (defclass show-conses-grid ()
;;   ((w :initarg :w
;;       :initform 2
;;       :documentation "The width of the grid, in characters.")
;;    (h :initarg :h
;;       :initform 2
;;       :documentation "The width of the grid, in characters.")
;;    (lines :initarg :lines
;;           :initform '(("ab") ("cd"))
;;           :documentation "The lines of the grid (a list)."))
;;   "Undocumented!")
;; 
;; (defun show-conses-from (lines)
;;   (let* ((expandedlines (show-conses-expand-lines lines))
;; 	 (w (show-conses-width-lines expandedlines))
;; 	 (h (length expandedlines))
;; 	 (paddedlines (show-conses-pad-lines expandedlines)))
;;     (show-conses-grid :w w :h h :lines paddedlines)))

;; (show-conses-from show-conses-demo-lines-4)

;; (h "car" "+")   means: a string whose text is "+"
;;                      and that highlights the region "car"
;;                      when we type `C-c C-c' on it.
;; (m "car-start") means: put the marker "car-start" here.
;; (m "car-end")   means: put the marker "car-end" here.


(find-es "emacs" "pair-tree")
https://github.com/zainab-ali/pair-tree.el
https://docs.racket-lang.org/sdraw/index.html

;; (find-es "emacs" "markers")
;; (find-es "emacs" "overlays")
;; (find-es "emacs" "make-hash-table")
;; (find-eev "eev-flash.el" "eeflash")






#  Local Variables:
#  coding:               utf-8-unix
#  End:
